import { Complex } from './type.js'
import {FnEqual} from '../interfaces/relational'

export const equal =
   <T>(dep: {
      equal: FnEqual<T>
   }): FnEqual<Complex<T>> =>
      (w, z) => dep.equal(w.re, z.re) && dep.equal(w.im, z.im)
